# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Test::LeakTrace isn't available unless we have Test::More ≥ 0.62
%global very_old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.62) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-List-MoreUtils
Version:	0.33
Release:	11.0.%{__distinit}%{__distvers}
Summary:	Provide the stuff missing in List::Util
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/List-MoreUtils/
Source0:	http://search.cpan.org/CPAN/authors/id/A/AD/ADAMK/List-MoreUtils-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
# ExtUtils::CBuilder -> IPC::Cmd -> Locale::Maketext::Simple -> Locale::Maketext::Lexicon -> PPI -> List::MoreUtils
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(ExtUtils::CBuilder)
%endif
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Pod::Simple)
BuildRequires:	perl(Test::CPAN::Meta)
%if ! %{very_old_test_more}
BuildRequires:	perl(Test::LeakTrace)
%endif
# Test::MinimumVersion -> Perl::MinimumVersion -> PPI -> List::MoreUtils
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Test::MinimumVersion)
%endif
BuildRequires:	perl(Test::More) >= 0.42
BuildRequires:	perl(Test::Pod)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
List::MoreUtils provides some trivial but commonly needed functionality
on lists that is not going to go into List::Util.

%prep
%setup -q -n List-MoreUtils-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type f -name '*.bs' -empty -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test
make test TEST_FILES="xt/*.t" AUTOMATED_TESTING=1

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README LICENSE
%{perl_vendorarch}/List/
%{perl_vendorarch}/auto/List/
%{_mandir}/man3/List::MoreUtils.3pm*

%changelog
* Thu Sep 19 2013 Paul Howarth <paul@city-fan.org> - 0.33-11.0
- Don't BR: perl(ExtUtils::CBuilder) when bootstrapping

* Mon Jul 22 2013 Paul Howarth <paul@city-fan.org> - 0.33-9.0
- Perl 5.18 rebuild

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 0.33-4.0
- Perl 5.16 post-bootstrap rebuild

* Tue Jul 10 2012 Paul Howarth <paul@city-fan.org> - 0.33-3.0
- BR:/R: perl(Carp)
- BR: perl(constant), perl(Exporter) and perl(ExtUtils::CBuilder)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Jan 24 2012 Paul Howarth <paul@city-fan.org> - 0.33-2.0
- Package LICENSE file
- Drop redundant buildreq perl(Test::Pod::Coverage)
- BR: perl(ExtUtils::MakeMaker) and perl(Test::More)
- BR: perl(Test::LeakTrace) where possible
- BR: perl(Pod::Simple) and (Test::CPAN::Meta)
- BR: perl(Test::MinimumVersion) unless we're bootstrapping
- Run the developer tests too

* Thu Aug  4 2011 Paul Howarth <paul@city-fan.org> - 0.33-1.0
- Update to 0.33
  - Updated can_xs to fix a bug in it

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.32-2.0
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri May 20 2011 Paul Howarth <paul@city-fan.org> - 0.32-1
- Update to 0.32
  - update copyright year
  - tweak documentation of all() and none()
  - memory leak fixed for apply() and XS version restored
  - memory leak fixed for indexes() and XS version restored
  - memory leak fixed for part() and XS version restored
  - more accurate detection of XS support
- Nobody else likes macros for commands

* Thu Dec 16 2010 Paul Howarth <paul@city-fan.org> - 0.30-1
- Update to 0.30
  - change the way we localise PERL_DL_NONLAZY to false to remove a warning
    that some people were seeing; the new approach is taken from the way that
    List::Util does it

* Wed Dec  8 2010 Paul Howarth <paul@city-fan.org> - 0.29-1
- Update to 0.29
  - refactored the split test scripts into a common test module to be shared
    between both the Perl and XS versions
  - reapply fix for CPAN RT#39847
    "minmax error: unpredictable results with lists of 1 element"
  - reduced test suite peak memory consumption by 5-10 meg
  - added the 'distinct' alias for the uniq function, for people that like
    their chained map/grep/sort pipelines with a SQL'ish flavour
  - expanded test suite for the any() group of functions
  - the any() group of functions now strictly always return scalar boolean
    true, false and undef to match the XS version
  - general house cleaning
  - the behaviour of any/all/none/notall has changed when passed a null list
    to treat a null list as a legitimate list (CPAN RT#40905)
  - disabled the leaking XS versions of part(), apply() and indexes()
  - restored the regression test for CPAN RT#38630 from 0.23
  - adding uniq warning tests, disabled initially

* Tue Nov 23 2010 Paul Howarth <paul@city-fan.org> - 0.26-1
- Update to 0.26 (first attempt at repackaging the List::MoreUtils code in
  Makefile.PL and release toolchain similar to Params::Util)
- New upstream maintainer ADAMK -> update source URL

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 0.25-4
- Rebuild for perl 5.12.1 in Rawhide

* Mon May 10 2010 Paul Howarth <paul@city-fan.org> - 0.25-3
- Fix dist tag to work with RHEL6 Beta

* Wed Feb 17 2010 Paul Howarth <paul@city-fan.org> - 0.25-2
- Dist tag for Rawhide no longer needs special-casing
- Use %%{?perl_default_filter} for provides filter

* Mon Aug  3 2009 Paul Howarth <paul@city-fan.org> - 0.25-1
- Update to 0.25_02 (note - CPAN RT#40905 fix is a backwards-incompatible change)
  - handle stack properly when stack grown from inside code-references
  - a couple of tests for each_arrayref were calling each_array
  - fix CPAN RT#40905 (don't return undef when none is passed an empty array)
  - fix CPAN RT#39847 (minmax err: unpredictable results w/ lists of 1 element)
  - fix CPAN RT#37533 (uniq doesn't like undef values)
  - fix CPAN RT#43214 (uniq warns on undef values)
  - fix CPAN RT#44518 (bug in pairwise as $a and $b lexically defined with my)
  - fix CPAN RT#41097 (big memory leak with XS part())
  - fix CPAN RT#41494 (memory leak in indexes() [XS])
  - reduce mem requirement for part() tests to fix many test suite failures
  - new function bsearch(), which performs a binary search
  - fix awkward ok() override in List-MoreUtils.t to improve diagnostics

* Sun Mar  1 2009 Paul Howarth <paul@city-fan.org> - 0.22-8
- Filter out unwanted provides for perl shared objects
- Update to SLES-compatible dist tag macros

* Mon Sep  1 2008 Paul Howarth <paul@city-fan.org> - 0.22-7
- Import from Fedora

* Thu Feb 28 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-6
- Rebuild normally, second pass

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-5
- Rebuild for perl 5.10 (again), tests disabled for first pass

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.22-4
- Autorebuild for GCC 4.3

* Mon Jan 14 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-3
- Rebuild normally, second pass

* Fri Jan 11 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.22-2.1
- Rebuild for new perl, first pass, disable TPC and tests

* Sun Sep 10 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-2
- Rebuild for FC6

* Mon Jul  3 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.22-1
- Update to 0.22

* Mon Jun 19 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.21-1
- Update to 0.21

* Sat Jun 10 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.20-1
- Update to 0.20

* Sat Apr 22 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 0.19-1
- First build
